<html>
<head>
<title>OgreD3D9VertexDeclaration.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_43d9b0265a5a2fd53bf3892a292ce5e9.html">RenderSystems</a>      </li>
      <li class="navelem"><a class="el" href="dir_c7ffc14721c8bed1493f4f78ca8c7331.html">Direct3D9</a>      </li>
      <li class="navelem"><a class="el" href="dir_1208738e8444befc5f502320df40a1ea.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreD3D9VertexDeclaration.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreD3D9VertexDeclaration_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __D3D9VERTEXDECLARATION_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __D3D9VERTEXDECLARATION_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgreD3D9Prerequisites_8h.html">OgreD3D9Prerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreHardwareVertexBuffer_8h.html">OgreHardwareVertexBuffer.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreD3D9Resource_8h.html">OgreD3D9Resource.h</a>&quot;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="keyword">namespace </span>Ogre { 
<a name="l00036"></a>00036 
<a name="l00038"></a><a class="code" href="classOgre_1_1D3D9VertexDeclaration.html">00038</a>     <span class="keyword">class </span><a class="code" href="OgreD3D9Prerequisites_8h.html#a2f097a9b4c2ebfb75896e7d6eec01a1d">_OgreD3D9Export</a> <a class="code" href="classOgre_1_1D3D9VertexDeclaration.html" title="Specialisation of VertexDeclaration for D3D9.">D3D9VertexDeclaration</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1VertexDeclaration.html" title="This class declares the format of a set of vertex inputs, which can be issued to the rendering API th...">VertexDeclaration</a>, <span class="keyword">public</span> <a class="code" href="classOgre_1_1D3D9Resource.html" title="Represents a Direct3D rendering resource.">D3D9Resource</a>
<a name="l00039"></a>00039     {
<a name="l00040"></a>00040     
<a name="l00041"></a>00041     <span class="keyword">public</span>:
<a name="l00042"></a>00042         <a class="code" href="classOgre_1_1D3D9VertexDeclaration.html" title="Specialisation of VertexDeclaration for D3D9.">D3D9VertexDeclaration</a>();
<a name="l00043"></a>00043         ~<a class="code" href="classOgre_1_1D3D9VertexDeclaration.html" title="Specialisation of VertexDeclaration for D3D9.">D3D9VertexDeclaration</a>();
<a name="l00044"></a>00044         
<a name="l00046"></a>00046         <span class="keyword">const</span> <a class="code" href="classOgre_1_1VertexElement.html" title="This class declares the usage of a single vertex buffer as a component of a complete VertexDeclaratio...">VertexElement</a>&amp; addElement(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> source, <span class="keywordtype">size_t</span> offset, <a class="code" href="group__RenderSystem.html#ga027109503a988ba85f4c63b55082907f" title="Vertex element type, used to identify the base types of the vertex contents.">VertexElementType</a> theType,
<a name="l00047"></a>00047             <a class="code" href="group__RenderSystem.html#ga0a62b3f2ede8992ff365bb013a8bc00d" title="Vertex element semantics, used to identify the meaning of vertex buffer contents.">VertexElementSemantic</a> semantic, <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> index = 0);
<a name="l00048"></a>00048 
<a name="l00050"></a>00050         <span class="keyword">const</span> <a class="code" href="classOgre_1_1VertexElement.html" title="This class declares the usage of a single vertex buffer as a component of a complete VertexDeclaratio...">VertexElement</a>&amp; insertElement(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> atPosition,
<a name="l00051"></a>00051             <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> source, <span class="keywordtype">size_t</span> offset, <a class="code" href="group__RenderSystem.html#ga027109503a988ba85f4c63b55082907f" title="Vertex element type, used to identify the base types of the vertex contents.">VertexElementType</a> theType,
<a name="l00052"></a>00052             <a class="code" href="group__RenderSystem.html#ga0a62b3f2ede8992ff365bb013a8bc00d" title="Vertex element semantics, used to identify the meaning of vertex buffer contents.">VertexElementSemantic</a> semantic, <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> index = 0);
<a name="l00053"></a>00053 
<a name="l00055"></a>00055         <span class="keywordtype">void</span> removeElement(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> elem_index);
<a name="l00056"></a>00056         
<a name="l00058"></a>00058         <span class="keywordtype">void</span> removeElement(<a class="code" href="group__RenderSystem.html#ga0a62b3f2ede8992ff365bb013a8bc00d" title="Vertex element semantics, used to identify the meaning of vertex buffer contents.">VertexElementSemantic</a> semantic, <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> index = 0);
<a name="l00059"></a>00059 
<a name="l00061"></a>00061         <span class="keywordtype">void</span> removeAllElements(<span class="keywordtype">void</span>);
<a name="l00062"></a>00062 
<a name="l00063"></a>00063 
<a name="l00065"></a>00065         <span class="keywordtype">void</span> modifyElement(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> elem_index, <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> source, <span class="keywordtype">size_t</span> offset, <a class="code" href="group__RenderSystem.html#ga027109503a988ba85f4c63b55082907f" title="Vertex element type, used to identify the base types of the vertex contents.">VertexElementType</a> theType,
<a name="l00066"></a>00066             <a class="code" href="group__RenderSystem.html#ga0a62b3f2ede8992ff365bb013a8bc00d" title="Vertex element semantics, used to identify the meaning of vertex buffer contents.">VertexElementSemantic</a> semantic, <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> index = 0);
<a name="l00067"></a>00067 
<a name="l00068"></a>00068         <span class="comment">// Called immediately after the Direct3D device has been created.</span>
<a name="l00069"></a>00069         <span class="keyword">virtual</span> <span class="keywordtype">void</span> notifyOnDeviceCreate(IDirect3DDevice9* d3d9Device);
<a name="l00070"></a>00070 
<a name="l00071"></a>00071         <span class="comment">// Called before the Direct3D device is going to be destroyed.</span>
<a name="l00072"></a>00072         <span class="keyword">virtual</span> <span class="keywordtype">void</span> notifyOnDeviceDestroy(IDirect3DDevice9* d3d9Device);
<a name="l00073"></a>00073 
<a name="l00075"></a>00075         IDirect3DVertexDeclaration9* getD3DVertexDeclaration(<a class="code" href="classOgre_1_1VertexDeclaration.html" title="This class declares the format of a set of vertex inputs, which can be issued to the rendering API th...">VertexDeclaration</a> * globalDeclaration, <span class="keywordtype">bool</span> useGlobalInstancingVertexBufferIsAvailable);
<a name="l00076"></a>00076 
<a name="l00077"></a>00077     <span class="keyword">protected</span>:
<a name="l00078"></a>00078         <span class="keywordtype">void</span>    releaseDeclaration();
<a name="l00079"></a>00079         <span class="keywordtype">void</span> convertElement( <span class="keyword">const</span> <a class="code" href="classOgre_1_1VertexElement.html" title="This class declares the usage of a single vertex buffer as a component of a complete VertexDeclaratio...">VertexElement</a> &amp; element, D3DVERTEXELEMENT9 &amp; dxElement );
<a name="l00080"></a>00080 
<a name="l00081"></a>00081     <span class="keyword">protected</span>:        
<a name="l00082"></a><a class="code" href="classOgre_1_1D3D9VertexDeclaration.html#acb454d7ad730f5018514cf2204d02a2d">00082</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html">map&lt;IDirect3DDevice9*, IDirect3DVertexDeclaration9*&gt;::type</a>  <a class="code" href="classOgre_1_1D3D9VertexDeclaration.html#acb454d7ad730f5018514cf2204d02a2d">DeviceToDeclarationMap</a>;
<a name="l00083"></a><a class="code" href="classOgre_1_1D3D9VertexDeclaration.html#ae1de70597b4c9c1b53d1a2b8b9c74dcb">00083</a>         <span class="keyword">typedef</span> DeviceToDeclarationMap::iterator                            <a class="code" href="classOgre_1_1D3D9VertexDeclaration.html#ae1de70597b4c9c1b53d1a2b8b9c74dcb">DeviceToDeclarationIterator</a>;
<a name="l00084"></a>00084 
<a name="l00085"></a><a class="code" href="classOgre_1_1D3D9VertexDeclaration.html#aa5d8572399731ad358b8eeb4039e889c">00085</a>         <a class="code" href="classOgre_1_1D3D9VertexDeclaration.html#acb454d7ad730f5018514cf2204d02a2d">DeviceToDeclarationMap</a>      <a class="code" href="classOgre_1_1D3D9VertexDeclaration.html#aa5d8572399731ad358b8eeb4039e889c">mMapDeviceToDeclaration</a>;
<a name="l00086"></a><a class="code" href="classOgre_1_1D3D9VertexDeclaration.html#a6f366f7e06ffc70919f964d8ec7e597c">00086</a>         <a class="code" href="classOgre_1_1VertexDeclaration.html" title="This class declares the format of a set of vertex inputs, which can be issued to the rendering API th...">VertexDeclaration</a> *         <a class="code" href="classOgre_1_1D3D9VertexDeclaration.html#a6f366f7e06ffc70919f964d8ec7e597c">mLastUsedGlobalDeclaration</a>;
<a name="l00087"></a><a class="code" href="classOgre_1_1D3D9VertexDeclaration.html#af135e2be5d157faf75601b06d5c1f57c">00087</a>         <span class="keywordtype">bool</span>                        <a class="code" href="classOgre_1_1D3D9VertexDeclaration.html#af135e2be5d157faf75601b06d5c1f57c">mUsedGlobalDeclaration</a>;
<a name="l00088"></a>00088     };
<a name="l00089"></a>00089 
<a name="l00090"></a>00090 }
<a name="l00091"></a>00091 
<a name="l00092"></a>00092 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:50
</p>
</body>
</html>
